/* Copyright (C) 2006 Kjetil Ørbekk, Norway */

#include <cairo.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct _graph {
  cairo_t *cr;
  cairo_surface_t *surface;
  int width;
  int height;
  int xoffset;
  int yoffset;
  float min_x;
  float max_x;
  float min_y;
  float max_y;
  float xs;
  float ys;
} graph;

int tz_local_offset() { return 7200; } // riktig?

void mygraph_fill_background(graph *mygraph);

void mygraph_draw_graph (cairo_t *cr, int x, int y );

graph *mygraph_new (int width, int height);

graph *mygraph_make_graph (graph *mygraph, float min_x,
			   float max_x, float min_y, float max_y,
			   int tickgran);

void mygraph_plot_series (graph *mygraph, int *xvals, int *yvals,
			  int n_vals, float r, float g, float b);

void mygraph_to_file (graph *mygraph, char *filename);

void mygraph_cleanup (graph *self);

void mygraph_fill_background (graph *mygraph);

